com.pivotal.gemfirexd.internal.client.am

## Class CallableStatement40

- java.lang.Object
- - com.pivotal.gemfirexd.internal.client.am.Statement
  - - com.pivotal.gemfirexd.internal.client.am.PreparedStatement
    - - com.pivotal.gemfirexd.internal.client.am.CallableStatement
      - - com.pivotal.gemfirexd.internal.client.am.CallableStatement40

All Implemented Interfaces:
  PreparedStatementCallbackInterface, StatementCallbackInterface, UnitOfWorkListener, AutoCloseable, CallableStatement, PreparedStatement, Statement, Wrapper

    public class CallableStatement40
    extends CallableStatement

### Field Summary

### Fields inherited from class com.pivotal.gemfirexd.internal.client.am.CallableStatement

`materialCallableStatement_`

### Fields inherited from class com.pivotal.gemfirexd.internal.client.am.PreparedStatement

`clientParamTypeAtFirstExecute, internalPreparedStatement, materialPreparedStatement_, outputRegistered_, parameterMetaData_, parameters_, pooledConnection_, singleHopInfoAlreadyFetched_, sql_, superFlowExecuteCalled_`

### Fields inherited from class com.pivotal.gemfirexd.internal.client.am.Statement

`autoGeneratedKeys_, cachedCursor_, cachedSingletonRowData_, CLOSE_ALL_RESULTS, CLOSE_CURRENT_RESULT, cursorAttributesToSendOnPrepare_, doWriteTimeout, fetchDirection_, fetchSize_, generatedKeysColumnIndexes_, generatedKeysColumnNames_, generatedKeysResultSet_, indexOfCurrentResultSet_, isCommitSql__, isPoolable, isPreparedStatement_, isQuery__, isRollbackSql__, KEEP_CURRENT_RESULT, materialStatement_, numInvisibleRS_, preparedStatementForAutoGeneratedKeys_, resultSetConcurrency_, resultSetHoldability_, resultSetType_, section_, SET_SCHEMA_STATEMENT, singletonRowData_, specialRegisterArrayList, sqlMode_, statementUUID, TIMEOUT_STATEMENT`

### Fields inherited from interface java.sql.Statement

`CLOSE_ALL_RESULTS, CLOSE_CURRENT_RESULT, EXECUTE_FAILED, KEEP_CURRENT_RESULT, NO_GENERATED_KEYS, RETURN_GENERATED_KEYS, SUCCESS_NO_INFO`

### Constructor Summary

Constructors
Constructor and Description
`CallableStatement40(Agent agent, Connection connection, String sql, int type, int concurrency, int holdability, ClientPooledConnection cpc)` Calls the superclass constructor and passes the parameters

### Method Summary

Methods
`void` `closeOnCompletion()`
`Reader` `getCharacterStream(String parameterName)`
`Reader` `getNCharacterStream(int parameterIndex)`
`Reader` `getNCharacterStream(String parameterName)`
`NClob` `getNClob(int i)`
`NClob` `getNClob(String parameterName)`
`String` `getNString(int parameterIndex)`
`String` `getNString(String parameterIndex)`
`<T> T` `getObject(int parameterIndex, Class<T> type)`
`<T> T` `getObject(String parameterName, Class<T> type)`
`RowId` `getRowId(int parameterIndex)`
`RowId` `getRowId(String parameterName)`
`SQLXML` `getSQLXML(int parameterIndex)`
`SQLXML` `getSQLXML(String parametername)`
`NetResultSet` `getSuperResultSet()`
`boolean` `isCloseOnCompletion()`
`void` `setAsciiStream(String parameterName, InputStream x)` End of methods from PreparedStatement for JDBC 4.0.
`void` `setAsciiStream(String parameterName, InputStream x, long length)` Sets the designated parameter to the given input stream, which will have the specified number of bytes.
`void` `setBinaryStream(String parameterName, InputStream x)`
`void` `setBinaryStream(String parameterName, InputStream x, long length)` Sets the designated parameter to the given input stream, which will have the specified number of bytes.
`void` `setBlob(String parameterName, Blob x)`
`void` `setBlob(String parameterName, InputStream inputStream)`
`void` `setBlob(String parameterName, InputStream inputStream, long length)`
`void` `setCharacterStream(String parameterName, Reader reader)`
`void` `setCharacterStream(String parameterName, Reader x, long length)` Sets the designated parameter to the given Reader, which will have the specified number of bytes.
`void` `setClob(String parameterName, Clob x)`
`void` `setClob(String parameterName, Reader reader)`
`void` `setClob(String parameterName, Reader reader, long length)`
`void` `setNCharacterStream(int parameterIndex, Reader value)`
`void` `setNCharacterStream(int index, Reader value, long length)`
`void` `setNCharacterStream(String parameterName, Reader value)`
`void` `setNCharacterStream(String parameterName, Reader value, long length)`
`void` `setNClob(int index, NClob value)`
`void` `setNClob(int parameterIndex, Reader reader)`
`void` `setNClob(int parameterIndex, Reader reader, long length)`
`void` `setNClob(String parameterName, NClob value)`
`void` `setNClob(String parameterName, Reader reader)`
`void` `setNClob(String parameterName, Reader reader, long length)`
`void` `setNString(int index, String value)` The methods from PreparedStatement for JDBC 4.0.
`void` `setNString(String parameterName, String value)`
`void` `setRowId(int parameterIndex, RowId x)`
`void` `setRowId(String parameterName, RowId x)`
`void` `setSQLXML(int parameterIndex, SQLXML xmlObject)`
`void` `setSQLXML(String parameterName, SQLXML xmlObject)`
`<T> T` `unwrap(Class<T> interfaces)` Returns `this` if this class implements the interface

### Methods inherited from class com.pivotal.gemfirexd.internal.client.am.CallableStatement

`clearParameters, finalize, getArray, getArray, getBigDecimal, getBigDecimal, getBigDecimal, getBlob, getBlob, getBoolean, getBoolean, getByte, getByte, getBytes, getBytes, getCharacterStream, getClob, getClob, getDate, getDate, getDate, getDate, getDouble, getDouble, getFloat, getFloat, getInt, getInt, getJdbcStatementInterfaceName, getLong, getLong, getObject, getObject, getObject, getObject, getRef, getRef, getShort, getShort, getString, getString, getTime, getTime, getTime, getTime, getTimestamp, getTimestamp, getTimestamp, getTimestamp, getURL, getURL, isCallMode, registerOutParameter, registerOutParameter, registerOutParameter, registerOutParameter, registerOutParameter, registerOutParameter, reset, resetCallableStatement, resetCallableStatement, resetCallableStatement, setAsciiStream, setBigDecimal, setBinaryStream, setBoolean, setByte, setBytes, setCharacterStream, setDate, setDate, setDouble, setFloat, setInt, setLong, setNull, setNull, setObject, setObject, setObject, setShort, setString, setTime, setTime, setTimestamp, setTimestamp, setURL, wasNull`

### Methods inherited from class com.pivotal.gemfirexd.internal.client.am.PreparedStatement

`addBatch, completeDescribeInput, completeDescribeOutput, completeLocalCommit, completeLocalRollback, execute, execute, execute, execute, execute, executeBatch, executeBatchX, executeQuery, executeQuery, executeUpdate, executeUpdate, executeUpdate, executeUpdate, executeUpdate, flowExecute, flowExecuteRead, flowExecuteWrite, getClientParamType, getMetaData, getParameterMetaData, initResetPreparedStatement, listenToUnitOfWork, makeNewClientParamTypeFrom, markClosed, readDescribeInput, readDescribeOutput, readExecute, resetPreparedStatement, resetPreparedStatement, resetPreparedStatement, setAndStoreClientParamType, setArray, setAsciiStream, setAsciiStream, setAsciiStream, setBigDecimal, setBinaryStream, setBinaryStream, setBinaryStream, setBinaryStreamX, setBlob, setBlob, setBlob, setBlobX, setBoolean, setByte, setBytes, setBytesX, setCharacterStream, setCharacterStream, setCharacterStream, setClob, setClob, setClob, setDate, setDate, setDouble, setFloat, setInt, setLong, setNull, setNull, setObject, setObject, setObject, setRef, setShort, setString, setTime, setTime, setTimestamp, setTimestamp, setUnicodeStream, setURL, singleHopPrepStmntExecuteQuery, writeDescribeInput, writeDescribeOutput, writeExecute`

### Methods inherited from class com.pivotal.gemfirexd.internal.client.am.Statement

`accumulateWarning, addBatch, cancel, checkForDuplicateCursorName, checkForStoredProcResultSetCount, cleanSingleHopPrepStmnt, clearBatch, clearWarnings, close, closeX, completeExecute, completeExecuteCall, completeExecuteCall, completeExecuteCallOpenQuery, completeExecuteImmediate, completeExecuteSetStatement, completeOpenQuery, completePrepare, completePrepareDescribeOutput, completeSqlca, completeStatementIDRead, getConnection, getConnectionCallbackInterface, getFetchDirection, getFetchSize, getGeneratedKeys, getGuessedResultSetMetaData, getMaxFieldSize, getMaxRows, getMoreResults, getMoreResults, getQueryTimeout, getResultSet, getResultSetConcurrency, getResultSetHoldability, getResultSetType, getSection, getSqlWarnings, getUpdateCount, getWarnings, initResetPreparedStatement, isClosed, isClosedNoThrow, isPoolable, isQueryMode, isWrapperFor, jdbc3FeatureNotSupported, jdbc3FeatureNotSupported, markAutoCommitted, needStatementUUID, readExecuteCall, readExecuteImmediate, readExecuteImmediateForBatch, readOpenQuery, readPrepare, readPrepareDescribeOutput, readSetSpecialRegister, readStatementID, removeClientCursorNameFromCache, resetStatement, resetStatement, resultSetCommitting, resultSetCommitting, setCursorName, setEscapeProcessing, setFetchDirection, setFetchSize, setMaxFieldSize, setMaxRows, setOwner, setPoolable, setQueryTimeout, setupCursorNameCacheAndMappings, setUpdateCount, substituteClientCursorNameWithServerCursorName, upperCaseProcedureName, writeExecuteCall, writeExecuteImmediate, writeGetStmtUUID, writeOpenQuery, writePrepare, writePrepareDescribeOutput, writeSetSpecialRegister`

### Methods inherited from class java.lang.Object

`clone, equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface java.sql.PreparedStatement

`addBatch, execute, executeQuery, executeUpdate, getMetaData, getParameterMetaData, setArray, setAsciiStream, setAsciiStream, setAsciiStream, setBigDecimal, setBinaryStream, setBinaryStream, setBinaryStream, setBlob, setBlob, setBlob, setBoolean, setByte, setBytes, setCharacterStream, setCharacterStream, setCharacterStream, setClob, setClob, setClob, setDate, setDate, setDouble, setFloat, setInt, setLong, setNull, setNull, setObject, setObject, setObject, setRef, setShort, setString, setTime, setTime, setTimestamp, setTimestamp, setUnicodeStream, setURL`

### Methods inherited from interface java.sql.Statement

`addBatch, cancel, clearBatch, clearWarnings, close, execute, execute, execute, execute, executeBatch, executeQuery, executeUpdate, executeUpdate, executeUpdate, executeUpdate, getConnection, getFetchDirection, getFetchSize, getGeneratedKeys, getMaxFieldSize, getMaxRows, getMoreResults, getMoreResults, getQueryTimeout, getResultSet, getResultSetConcurrency, getResultSetHoldability, getResultSetType, getUpdateCount, getWarnings, isClosed, isPoolable, setCursorName, setEscapeProcessing, setFetchDirection, setFetchSize, setMaxFieldSize, setMaxRows, setPoolable, setQueryTimeout`

### Methods inherited from interface java.sql.Wrapper

`isWrapperFor`

### Methods inherited from interface com.pivotal.gemfirexd.internal.client.am.PreparedStatementCallbackInterface

`completeDescribeInput, completeDescribeOutput`

### Methods inherited from interface com.pivotal.gemfirexd.internal.client.am.StatementCallbackInterface

`accumulateWarning, completeExecute, completeExecuteCall, completeExecuteCall, completeExecuteCallOpenQuery, completeExecuteImmediate, completeExecuteSetStatement, completeOpenQuery, completePrepare, completePrepareDescribeOutput, completeSqlca, completeStatementIDRead, getConnectionCallbackInterface, getGuessedResultSetMetaData, getSection`

### Methods inherited from interface com.pivotal.gemfirexd.internal.client.am.UnitOfWorkListener

`completeLocalCommit, completeLocalRollback, listenToUnitOfWork`

### Constructor Detail

#### CallableStatement40

    public CallableStatement40(Agent agent,
                       Connection connection,
                       String sql,
                       int type,
                       int concurrency,
                       int holdability,
                       ClientPooledConnection cpc)
                        throws SqlException

Calls the superclass constructor and passes the parameters

Parameters:
  `agent` - The instance of NetAgent associated with this CallableStatement object.
  `connection` - The connection object associated with this PreparedStatement Object.
  `sql` - A String object that is the SQL statement to be sent to the database.
  `type` - One of the ResultSet type constants
  `concurrency` - One of the ResultSet concurrency constants
  `holdability` - One of the ResultSet holdability constants
  `cpc` - The PooledConnection object that will be used to notify the PooledConnection reference of the Error Occurred and the Close events.
Throws:
  `SqlException`

### Method Detail

#### getCharacterStream

    public Reader getCharacterStream(String parameterName)
                              throws SQLException

Throws:
  `SQLException`

#### getNCharacterStream

    public Reader getNCharacterStream(int parameterIndex)
                               throws SQLException

Throws:
  `SQLException`

#### getNCharacterStream

    public Reader getNCharacterStream(String parameterName)
                               throws SQLException

Throws:
  `SQLException`

#### getNString

    public String getNString(int parameterIndex)
                      throws SQLException

Throws:
  `SQLException`

#### getNString

    public String getNString(String parameterIndex)
                      throws SQLException

Throws:
  `SQLException`

#### getRowId

    public RowId getRowId(int parameterIndex)
                   throws SQLException

Throws:
  `SQLException`

#### getRowId

    public RowId getRowId(String parameterName)
                   throws SQLException

Throws:
  `SQLException`

#### setRowId

    public void setRowId(String parameterName,
                RowId x)
                  throws SQLException

Throws:
  `SQLException`

#### setBlob

    public void setBlob(String parameterName,
               Blob x)
                 throws SQLException

Throws:
  `SQLException`

#### setClob

    public void setClob(String parameterName,
               Clob x)
                 throws SQLException

Throws:
  `SQLException`

#### setNString

    public void setNString(String parameterName,
                  String value)
                    throws SQLException

Throws:
  `SQLException`

#### setNCharacterStream

    public void setNCharacterStream(String parameterName,
                           Reader value,
                           long length)
                             throws SQLException

Throws:
  `SQLException`

#### setNClob

    public void setNClob(String parameterName,
                NClob value)
                  throws SQLException

Throws:
  `SQLException`

#### setClob

    public void setClob(String parameterName,
               Reader reader,
               long length)
                 throws SQLException

Throws:
  `SQLException`

#### setBlob

    public void setBlob(String parameterName,
               InputStream inputStream,
               long length)
                 throws SQLException

Throws:
  `SQLException`

#### setNClob

    public void setNClob(String parameterName,
                Reader reader,
                long length)
                  throws SQLException

Throws:
  `SQLException`

#### getNClob

    public NClob getNClob(int i)
                   throws SQLException

Throws:
  `SQLException`

#### getNClob

    public NClob getNClob(String parameterName)
                   throws SQLException

Throws:
  `SQLException`

#### setSQLXML

    public void setSQLXML(String parameterName,
                 SQLXML xmlObject)
                   throws SQLException

Throws:
  `SQLException`

#### getSQLXML

    public SQLXML getSQLXML(int parameterIndex)
                     throws SQLException

Throws:
  `SQLException`

#### getSQLXML

    public SQLXML getSQLXML(String parametername)
                     throws SQLException

Throws:
  `SQLException`

#### setRowId

    public void setRowId(int parameterIndex,
                RowId x)
                  throws SQLException

Throws:
  `SQLException`

#### setNString

    public void setNString(int index,
                  String value)
                    throws SQLException

The methods from PreparedStatement for JDBC 4.0. * These are added here because we can't inherit * PreparedStatement40.java. Instead of moving the non-implemented * classes to PreparedStatement.java, we duplicate them here. *

Throws:
  `SQLException`

#### setNCharacterStream

    public void setNCharacterStream(int parameterIndex,
                           Reader value)
                             throws SQLException

Throws:
  `SQLException`

#### setNCharacterStream

    public void setNCharacterStream(int index,
                           Reader value,
                           long length)
                             throws SQLException

Throws:
  `SQLException`

#### setNClob

    public void setNClob(int index,
                NClob value)
                  throws SQLException

Throws:
  `SQLException`

#### setNClob

    public void setNClob(int parameterIndex,
                Reader reader)
                  throws SQLException

Throws:
  `SQLException`

#### setNClob

    public void setNClob(int parameterIndex,
                Reader reader,
                long length)
                  throws SQLException

Throws:
  `SQLException`

#### setSQLXML

    public void setSQLXML(int parameterIndex,
                 SQLXML xmlObject)
                   throws SQLException

Throws:
  `SQLException`

#### setAsciiStream

    public void setAsciiStream(String parameterName,
                      InputStream x)
                        throws SQLException

End of methods from PreparedStatement for JDBC 4.0. *

Throws:
  `SQLException`

#### setBinaryStream

    public void setBinaryStream(String parameterName,
                       InputStream x)
                         throws SQLException

Throws:
  `SQLException`

#### setBlob

    public void setBlob(String parameterName,
               InputStream inputStream)
                 throws SQLException

Throws:
  `SQLException`

#### setCharacterStream

    public void setCharacterStream(String parameterName,
                          Reader reader)
                            throws SQLException

Throws:
  `SQLException`

#### setClob

    public void setClob(String parameterName,
               Reader reader)
                 throws SQLException

Throws:
  `SQLException`

#### setNCharacterStream

    public void setNCharacterStream(String parameterName,
                           Reader value)
                             throws SQLException

Throws:
  `SQLException`

#### setNClob

    public void setNClob(String parameterName,
                Reader reader)
                  throws SQLException

Throws:
  `SQLException`

#### unwrap

    public <T> T unwrap(Class<T> interfaces)
             throws SQLException

Returns `this` if this class implements the interface

Parameters:
  `interfaces` - a Class defining an interface
Returns:
  an object that implements the interface
Throws:
  `java.sql.SQLExption` - if no object if found that implements the interface
  `SQLException`

#### setAsciiStream

    public final void setAsciiStream(String parameterName,
                      InputStream x,
                      long length)
                              throws SQLException

Sets the designated parameter to the given input stream, which will have the specified number of bytes.

Parameters:
  `parameterName` - the name of the first parameter
  `x` - the java input stream which contains the ASCII parameter value
  `length` - the number of bytes in the stream
Throws:
  `SQLException` - thrown on failure.

#### setBinaryStream

    public final void setBinaryStream(String parameterName,
                       InputStream x,
                       long length)
                               throws SQLException

Sets the designated parameter to the given input stream, which will have the specified number of bytes.

Parameters:
  `parameterName` - the name of the first parameter
  `x` - the java input stream which contains the binary parameter value
  `length` - the number of bytes in the stream
Throws:
  `SQLException` - thrown on failure.

#### setCharacterStream

    public final void setCharacterStream(String parameterName,
                          Reader x,
                          long length)
                                  throws SQLException

Sets the designated parameter to the given Reader, which will have the specified number of bytes.

Parameters:
  `parameterName` - the name of the first parameter
  `x` - the java Reader which contains the UNICODE value
  `length` - the number of bytes in the stream
Throws:
  `SQLException` - thrown on failure.

#### closeOnCompletion

    public void closeOnCompletion()
                           throws SQLException

Throws:
  `SQLException`

#### isCloseOnCompletion

    public boolean isCloseOnCompletion()
                                throws SQLException

Throws:
  `SQLException`

#### getObject

    public <T> T getObject(int parameterIndex,
                  Class<T> type)
                throws SQLException

Throws:
  `SQLException`

#### getObject

    public <T> T getObject(String parameterName,
                  Class<T> type)
                throws SQLException

Throws:
  `SQLException`

#### getSuperResultSet

    public NetResultSet getSuperResultSet()
                                   throws SQLException

Overrides:
  `getSuperResultSet` in class `PreparedStatement`
Throws:
  `SQLException`